package com.icontrols.image;

import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.CorsRegistry;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.ResourceHandlerRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

@Configuration
public class WebController implements WebMvcConfigurer{
	@Override
	public void addCorsMappings(CorsRegistry registry) {
		// TODO Auto-generated method stub
		registry.addMapping("/images/**").allowedMethods("GET").allowCredentials(false);
		//WebMvcConfigurer.super.addCorsMappings(registry);
	}

	@Override
	public void addResourceHandlers(ResourceHandlerRegistry registry) {
		try
		{
			// 참고자료 https://jyc228.tistory.com/10

			// TODO Auto-generated method stub
			if( isWindows())
			{
				registry.addResourceHandler("images/**").addResourceLocations("file:/c:/resource/");
			}
			else 
			{
				registry.addResourceHandler("images/**").addResourceLocations("file:/srv/valley/data/vsftpd/uploads/");
			}
			//WebMvcConfigurer.super.addResourceHandlers(registry);
		}catch( Exception e)
		{
			e.printStackTrace();
		}
	}


	@Override
	public void addInterceptors(InterceptorRegistry registry) {
		// TODO Auto-generated method stub
		MsgIntercepter loginIntercepter = new MsgIntercepter();
        registry.addInterceptor(loginIntercepter)
                .addPathPatterns()
                .excludePathPatterns();
		//WebMvcConfigurer.super.addInterceptors(registry);
	}

	public boolean isWindows()
	{
	    String OS = System.getProperty("os.name").toLowerCase();
	    
	    if( OS.indexOf("win") >= 0 )
	    {
	    	return true;
	    }
	    return false;
	}
}
